Label Switched Path (LSP) Ping for Segment Routing (SR) Path Segment Identifier with MPLS Data Planes
Xiao Min
ZTE Corp.
Nanjing
China
+86 18061680168
xiao.min2@zte.com.cn
Shaofu Peng
ZTE Corp.
Nanjing
China
peng.shaofu@zte.com.cn
Liyan Gong
China Mobile
Beijing
China
gongliyan@chinamobile.com
Rakesh Gandhi
Cisco Systems, Inc.
Canada
rgandhi@cisco.com
Carlos Pignataro
North Carolina State University
United States of America
cpignata@gmail.com
cmpignat@ncsu.edu
2024
Routing
MPLS Working Group
Request for Comments
RFC
Internet Draft
I-D
Path Segment is a type of Segment Routing (SR) segment, and a Path Segment Identifier (PSID) is used to identify an SR path. Path Segment can be used in an SR over MPLS (SR-MPLS) data plane. This document provides Target Forwarding Equivalence Class (FEC) Stack TLV and sub-TLV definitions for PSID.

Introduction
Path Segment is a type of Segment Routing (SR) segment, and a Path Segment Identifier (PSID) is used to identify an SR path. PSID in MPLS-based segment routing networks is defined in [RFC9545].
As specified in [RFC9545], PSID is a single label inserted by the ingress node of the SR path, and then processed by the egress node of the SR path. The PSID is placed within the MPLS label stack as a label immediately following the last label of the SR path. The egress node MUST pop the PSID.
This document provides Target Forwarding Equivalence Class (FEC) Stack TLV and sub-TLV definitions for PSID. Procedures for LSP Ping as defined in [RFC8287] and [RFC8690] are applicable to PSID as well. Note that LSP Traceroute is left out of this document because the transit node is not involved in PSID processing.

Conventions

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Terminology
This document uses the terminology defined in [RFC3031], [RFC8402], and [RFC8029], readers are expected to be familiar with those terms.

Path Segment ID Sub-TLVs
Analogous to what's defined in Section 5 of [RFC8287] and Section 4 of [I-D.ietf-mpls-sr-epe-oam], three new sub-TLVs are defined for the Target FEC Stack TLV (Type 1), the Reverse-Path Target FEC Stack TLV (Type 16), and the Reply Path TLV (Type 21).

     Sub-Type    Sub-TLV Name
     --------    -----------------------------
      TBD1       SR Policy's PSID
      TBD2       SR Candidate Path's PSID
      TBD3       SR Segment List's PSID

As specified in Section 2 of [RFC9545], a PSID is used to identify a segment list, some or all segment lists in a Candidate path or an SR policy, so three different Target FEC Stack sub-TLVs need to be defined for PSID. When a PSID is used to identify an SR Policy, the Target FEC Stack sub-TLV of the type "SR Policy's PSID" would be used to validate the control plane to forwarding plane synchronization for this PSID; When a PSID is used to identify an SR Candidate Path, the Target FEC Stack sub-TLV of the type "SR Candidate Path's PSID" would be used to validate the control plane to forwarding plane synchronization for this PSID; When a PSID is used to identify a Segment List, the Target FEC Stack sub-TLV of the type "SR Segment List's PSID" would be used to validate the control plane to forwarding plane synchronization for this PSID. Note that the three new Target FEC Stack sub-TLVs are mutual exclusive and they wouldn't be present in one message simultaneously.

SR Policy's PSID
The format of SR Policy's PSID sub-TLV is specified as below:

SR Policy's PSID sub-TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|          Type = TBD1          |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                     Headend  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Color  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                    Endpoint  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type
This field is set to the value (TBD1) which indicates that it's an SR Policy's PSID sub-TLV.
Length
This field is set to the length of the sub-TLV's Value field in octets. If Headend and Endpoint fields are in IPv4 address format which is 4 octets long, it MUST be set to 12; If Headend and Endpoint fields are in IPv6 address format which is 16 octets long, it MUST be set to 36.
Headend
The same as defined in Section 2.1 of [RFC9256].
Color
The same as defined in Section 2.1 of [RFC9256].
Endpoint
The same as defined in Section 2.1 of [RFC9256].

SR Candidate Path's PSID
The format of SR Candidate Path's PSID sub-TLV is specified as below:

SR Candidate Path's PSID sub-TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|          Type = TBD2          |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                     Headend  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Color  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                    Endpoint  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Protocol-Origin|                    Reserved                   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
|                                                               |
|                  Originator  (20 octets)                      |
|                                                               |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|               Discriminator  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type
This field is set to the value (TBD2) which indicates that it's an SR Candidate Path's PSID sub-TLV.
Length
This field is set to the length of the sub-TLV's Value field in octets. If Headend and Endpoint fields are in IPv4 address format which is 4 octets long, it MUST be set to 40; If Headend and Endpoint fields are in IPv6 address format which is 16 octets long, it MUST be set to 64.
Headend
The same as defined in Section 2.1 of [RFC9256].
Color
The same as defined in Section 2.1 of [RFC9256].
Endpoint
The same as defined in Section 2.1 of [RFC9256].
Protocol-Origin
The same as defined in Section 2.3 of [RFC9256]. The value of this field follows the IANA registry requested in Section 6.5 of [I-D.ietf-pce-segment-routing-policy-cp].
Originator
The same as defined in Section 2.4 of [RFC9256].
Discriminator
The same as defined in Section 2.5 of [RFC9256].

SR Segment List's PSID
The format of SR Segment List's PSID sub-TLV is specified as below:

SR Segment List's PSID sub-TLV

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|          Type = TBD3          |             Length            |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                     Headend  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                       Color  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
~                    Endpoint  (4/16 octets)                    ~
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Protocol-Origin|                    Reserved                   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
|                                                               |
|                  Originator  (20 octets)                      |
|                                                               |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|               Discriminator  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|             Segment-List-ID  (4 octets)                       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type
This field is set to the value (TBD3) which indicates that it's an SR Segment List's PSID sub-TLV.
Length
This field is set to the length of the sub-TLV's Value field in octets. If Headend and Endpoint fields are in IPv4 address format which is 4 octets long, it MUST be set to 44; If Headend and Endpoint fields are in IPv6 address format which is 16 octets long, it MUST be set to 68.
Headend
The same as defined in Section 2.1 of [RFC9256].
Color
The same as defined in Section 2.1 of [RFC9256].
Endpoint
The same as defined in Section 2.1 of [RFC9256].
Protocol-Origin
The same as defined in Section 2.3 of [RFC9256]. The value of this field follows the IANA registry requested in Section 6.5 of [I-D.ietf-pce-segment-routing-policy-cp].
Originator
The same as defined in Section 2.4 of [RFC9256].
Discriminator
The same as defined in Section 2.5 of [RFC9256].
Segment-List-ID
This field identifies an SR path within the context of a candidate path of an SR Policy. The segment-list-id is a 4-octet identifier of a segment list.

PSID FEC Validation
The MPLS LSP Ping procedures may be initiated by the headend of the Segment Routing path or a centralized topology-aware data plane monitoring system as described in [RFC8403]. For the PSID, the responder nodes that receive echo request and send echo reply MUST be the endpoint of the Segment Routing path.
When an endpoint receives the LSP echo request packet with top FEC being the PSID, it MUST perform validity checks on the content of the PSID FEC Stack sub-TLV. The basic length check should be performed on the received FEC.

    SR Policy's PSID
    ------------------
    Length = 12 or 36 octets

    SR Candidate Path's PSID
    ------------------
    Length = 40 or 64 octets

    SR Segment List's PSID
    ------------------
    Length = 44 or 68 octets

If a malformed FEC Stack sub-TLV is received, then a return code of 1, "Malformed echo request received" as defined in [RFC8029] SHOULD be sent. The below section augments Section 7.4 of [RFC8287].
4a. Segment Routing PSID Validation:
If the Label-stack-depth is 0 and the Target FEC Stack sub-TLV at FEC-stack-depth is TBD1 (SR Policy's PSID sub-TLV), {
  Set the Best-return-code to 10, "Mapping for this FEC is not the given label at stack-depth <RSC>" if any below conditions fail (the notation <RSC> refers to the Return Subcode):
    - Validate that the PSID is signaled or provisioned for the SR Policy {
      - Validate that the signaled or provisioned headend, color, and endpoint, for the PSID, matches with the corresponding fields in the received SR Policy's PSID sub-TLV.
}
}
  If all the above validations have passed, set the return code to 3 "Replying router is an egress for the FEC at stack-depth <RSC>".
  Set FEC-Status to 1 and return.
}
Else, if the Label-stack-depth is 0 and the Target FEC Stack sub-TLV at FEC-stack-depth is TBD2 (SR Candidate Path's PSID sub-TLV), {
  Set the Best-return-code to 10, "Mapping for this FEC is not the given label at stack-depth <RSC>" if any below conditions fail:
    - Validate that the PSID is signaled or provisioned for the SR Candidate Path {
      - Validate that the signaled or provisioned headend, color, endpoint, originator, and discriminator, for the PSID, matches with the corresponding fields in the received SR Candidate Path's PSID sub-TLV.
}
}
  If all the above validations have passed, set the return code to 3 "Replying router is an egress for the FEC at stack-depth <RSC>".
  Set FEC-Status to 1 and return.
}
Else, if the Label-stack-depth is 0 and the Target FEC Stack sub-TLV at FEC-stack-depth is TBD3 (SR Segment List's PSID sub-TLV), {
  Set the Best-return-code to 10, "Mapping for this FEC is not the given label at stack-depth <RSC>" if any below conditions fail:
    - Validate that the PSID is signaled or provisioned for the SR Segment List {
      - Validate that the signaled or provisioned headend, color, endpoint, originator, discriminator, and segment-list-id, for the PSID, matches with the corresponding fields in the received SR Segment List's PSID sub-TLV.
}
}
  If all the above validations have passed, set the return code to 3 "Replying router is an egress for the FEC at stack-depth <RSC>".
  Set FEC-Status to 1 and return.
}
When a sub-TLV defined in this document is carried in Reverse-Path Target FEC Stack TLV (Type 16) or Reply Path TLV (Type 21), it MUST be sent by an endpoint in an echo reply. The headend MUST perform validity checks as described above without setting the return code. If any of the validations fail, then the headend MUST drop the echo reply and SHOULD log and/or report an error.

Security Considerations
This document defines additional MPLS LSP Ping sub-TLVs and follows the mechanisms defined in [RFC8029]. All the security considerations defined in [RFC8029] will be applicable for this document and, in addition, the MPLS LSP Ping sub-TLVs defined in this document do not impose any additional security challenges to be considered.

IANA Considerations
IANA is requested to assign three new sub-TLVs from the "Sub-TLVs for TLV Types 1, 16, and 21" sub-registry in the "TLVs" registry of the "Multiprotocol Label Switching (MPLS) Label Switched Paths (LSPs) Ping Parameters" name space. The Standards Action range that requires an error message to be returned if the sub-TLV is not recognized (range 0-16383) should be used.

  Sub-Type   Sub-TLV Name                Reference
  --------   -------------------------   ------------
   TBD1      SR Policy's PSID            Section 3.1
   TBD2      SR Candidate Path's PSID    Section 3.2
   TBD3      SR Segment List's PSID      Section 3.3

Acknowledgements
The authors would like to acknowledge Loa Andersson, Detao Zhao, Ben Niven-Jenkins, Greg Mirsky, and Ketan Talaulikar for their thorough review and very helpful comments.
The authors would like to acknowledge Yao Liu and Quan Xiong for the very helpful f2f discussion.

Normative References

Informative References
[RFC9545]
[RFC8287]
[RFC8690]
[RFC2119]
[RFC8174]
[RFC3031]
[RFC8402]
[RFC8029]
[I-D.ietf-mpls-sr-epe-oam]
[RFC9256]
[I-D.ietf-pce-segment-routing-policy-cp]
[RFC8403]